/*
   gruppo ACME inc 2000
   Linguaggio Macchina Ropeland

   @TITLE Rope Land
   @AUTHOR R.Corda
   @VERSION v0.2.18042000

   Copyright (c) 1970-2000, Autore sorgenti:
   Roberto Corda (roberto.corda@inferentia.it) 

   All rights reserved.

   This file is subject to the terms of the GNU General Public License as
   published by the Free Software Foundation.  A copy of this license is
   included with this software distribution in the file COPYING.  If you
   do not have a copy, you may obtain a copy by writing to the Free
   Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#define MAXVARS 10
#define MAXCMD 30
#define MAXROPES 1000
#define LATO 20
#define POOLCMD 30

#define GOD 0

typedef struct {
 char ctrl[3]; // 0 value 1 ivar
 int rlm;      // comando
 int p[3];     // parametri
} tcmd;

typedef struct {
  int vars[MAXVARS];  // variabili, memoria del rope
  int pc;             // program counter
  int cond;           // accumulatore fix: non usato, cancellare?
} tstatus;

typedef struct {
  tcmd cmd[MAXCMD];  // programma in rlm (Ling Macchina)
  int numcmd;        // numero di comandi aka lunghezza programma
  tstatus status;    // stato della VM relativa a questo rope
} tprocess;

typedef struct {
                  // valori immessi automaticamente
  int id;         // identificatore oggetto 
  long birthday;  // data di nascita
  int alive;      // vivo o morto

                  // valori immessi manualmente
  int father_id;  // identificatore padre oggetto
  int mother_id;  // identificatore madre oggetto fix: non utilizzato
  int type;       // tipo STONE,TREE,BAMBY,LION
  int erg;        // energia
  int weight;     // peso fix: non utilizzato
  int x;          // posizione
  int y;
  int dir;        // direzione e energia inerziale
  int inerzia;
  tprocess *proc; // processo, NULL se morto o ROCK

} tobj;

typedef struct {
 tobj *obj;       // puntatore all'oggetto
 int signal;      // segnale presente nella posizione
 int time;        // quando e' stato emesso il segnale
} tland;

enum types {ROCK,TREE,LAMB,LION,SIGNAL,BKG};
enum mdirs {NORTH,NE,EAST,SE,SOUTH,SW,WEST,NW};
enum ctrls {VAL, PNT} ;
enum rlms {NOTACMD,LOAD,IF,HALT,
     AND,OR,NOT,LT,EQ,
     MOVE,SPEAK,EAR,SEE,
     DUP,EATV,EATM,EATL,FEED,
     ADD,SUB,INC,DEC,
     RADAR, ERG,FATHER,TYPE,ID,BIRTH,TIC,RAND};
extern int  npar[30] ;
extern char *ctrlname[2];
extern char *rlmname[30];
extern tland ropeland[LATO+2][LATO+2]; // terreno di gioco

/* fix da aggiungere?
extern tobj *ropes[MAXROPES];           // ropes viventi sassi e cadaveri
extern int id;                          // ultimo id assegnato
extern int active;                      // numero oggetti schedulati
extern int alive;                       // numero di oggetti vivi
extern long tic;                        // tempo passato
extern int type;                        // tipo di scontro MATCH o DARWIN
extern int debugval;                    // se vero serve per il debug
*/

int god();                             // schedulatore oggetti
int debug();                           // stato di debug?

