
/*
   Interfaccia Grafica (con Allegro)
   
   @TITLE Rope Land
   @AUTHOR R.Corda
   @VERSION v0.313.07052000

   Copyright (c) 2000, Roberto Corda (roberto.corda@inferentia.it)
   All rights reserved.

   This file is subject to the terms of the GNU General Public License as
   published by the Free Software Foundation.  A copy of this license is
   included with this software distribution in the file COPYING.  If you
   do not have a copy, you may obtain a copy by writing to the Free
   Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   Allegro e DJGPP possono essere scaricati da http:\\www.delorie.com
*/

#include <conio.h>
#include "allegro.h"

//fix: solo per delay()
#include <dos.h>

#include "rope.h"
#include "ropegui.h"

// define per interfaccia a caratteri
#define STARTX 2
#define STARTY 2

// fix: farle diventare variabili e prenderle dall'esterno?
// ritarda la visualizzazione se ISDELAY == 1
// di DELAY millisecondi
#define DELAY 10
#define ISDELAY 0

// variabili globali per interfaccia a caratteri
// AAA: sono nello stesso ordine dell'enum types in rope.h
char *typestr[6] = {"*","?","B","L","'","."};
// fix: cambiare il valore dall'esterno
int nograph = 1;

/* variabili globali per interfaccia grafica con allegro */
//fix: manca la bitmap del signal (4)
BITMAP *typebmp[6];

int latobmp;

// movegui a caratteri vedi _movegui
int _moveguichar(int x1,int y1, int x2, int y2,char *what){
   gotoxy(x1+STARTX+1,y1+STARTY+1);
   printf(typestr[BKG]);
   gotoxy(x2+STARTX+1,y2+STARTY+1);
   printf(what);
   if (ISDELAY)
    delay(DELAY);
   return TRUE;
   return TRUE;
}

// usa effettivamente la libreria allegro per
// spostare l'oggetto visuale da (x1,y1) in (x2,y2)
// restituisce FALSE se non viene eseguito
int _movegui(int x1,int y1, int x2, int y2,BITMAP *what){
  _putgui(x1,y1, typebmp[BKG]);
  _putgui(x2,y2, what);
  if (ISDELAY)
    delay(DELAY);
  return TRUE;
}

// interfaccia con l'esterno trasforma le posizioni x,y da logiche a
// fisiche e richiama _moveguiXXX(..)
// se nograph == FALSE  grafica con allegro
// se nograph == TRUE   a caratteri
int movegui(int x1,int y1, int x2, int y2,int type){
  if (debug())
    return FALSE;
  // a caratteri
  if (nograph) {
   _moveguichar(x1,y1, x2, y2,typestr[type]);
   return TRUE;
  }

  // grafica con allegro
  x2 = x2*latobmp + STARTX;
  y2 = y2*latobmp + STARTY;
  x1 = x1*latobmp + STARTX;
  y1 = y1*latobmp + STARTY;
  _movegui(x1,y1, x2, y2,typebmp[type]);
}

int _putguichar(int x, int y, char *what){
   gotoxy(x+STARTX+1,y+STARTY+1);
   printf(what);
   return TRUE;
}
// usa effettivamente la libreria allegro per
// porre un oggetto in (x,y)
// fix: restituisce sempre TRUE
int _putgui(int x, int y, BITMAP *what) {
  // grafica con allegro
  blit(what, screen, 0, 0, x, y, latobmp, latobmp);

  if (ISDELAY)
    delay(DELAY); //fix: del this delay
  return TRUE;
}

//interfaccia con l'esterno per _putgui()
int  putgui(int x, int y, int type) {

  if (debug())
    return 0;
  // caratteri
  if (nograph) {
   _putguichar(x,y,typestr[type]);
   return TRUE;
  }

  // grafica
  x = x*latobmp + STARTX;
  y = y*latobmp + STARTY;
  _putgui(x,y,typebmp[type]);
}

// interfaccia con l'esterno pone il colore di back ground in posizione
// (x,y)
int delgui(int x, int y) {
  if (debug())
    return 0;

  // a caratteri
  if (nograph) {
   gotoxy(x+STARTX+1,y+STARTY+1);
   printf(typestr[BKG]);
   return TRUE;
  }
  // grafica con allegro
  x = x*latobmp + STARTX;
  y = y*latobmp + STARTY;
  _putgui(x,y,typebmp[BKG]);
  if (ISDELAY)
    delay(DELAY); //fix: del this delay
  return TRUE;
}

/*
 * Thanks to example program for the Allegro library, 
 * by Shawn Hargreaves.
*/
// inizializza l'interfaccia grafica se nograph == FALSE
// altrimenti quella a caratteri (nograph == TRUE)
int initgui(){
 int x;
 PALETTE pal;

 if (debug())
    return 0;

 // a caratteri
 if (nograph) {
  clrscr();
  return TRUE;
 }

 // grafica con allegro
 /* you should always do this at the start of Allegro programs */
 allegro_init();

 /* set up the keyboard handler */
 install_keyboard();

 // fix: usare anche gli altri modi grafici
 if (set_gfx_mode(GFX_MODEX, 320, 240, 0, 0) != 0) {
      allegro_exit();
      printf("Error setting graphics mode\n");
      exit(1);
   }
 clear(screen);
 latobmp = 10;

 // fix: le immagini sono solo 10 X 10
 // carica le immagini
 if (!(typebmp[ROCK] = load_bitmap("rock.bmp",pal))) {
      printf("Error reading bitmap file rock.bmp\n");
      exit(0);
   }
 
 if (!(typebmp[TREE] = load_bitmap("tree.bmp",pal))) {
      printf("Error reading bitmap file tree.bmp\n");
      exit(0);
   }

 if (!(typebmp[LAMB] = load_bitmap("lamb.bmp",pal))) {
      printf("Error reading bitmap file lamb.bmp\n");
      exit(0);
   }

 if (!(typebmp[LION] = load_bitmap("lion.bmp",pal))) {
      printf("Error reading bitmap file lion.bmp\n");
      exit(0);
   }
 typebmp[SIGNAL] = create_bitmap(latobmp,latobmp);
 clear(typebmp[SIGNAL]);
 rect(typebmp[SIGNAL],1,1,latobmp-1,latobmp-1,0);

 typebmp[BKG] = create_bitmap(latobmp,latobmp);
 clear(typebmp[BKG]);
 rect(typebmp[BKG],1,1,latobmp-1,latobmp-1,2);

 /* set the color pallete */
 set_pallete(pal);
 return 0;
}

int closegui() {
// fix: al momento non fa niente
// if (!nograph) {
// set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
//  allegro_exit();
// }
return 0;
}



